// danse.C Version 7.40e  Copyleft (c) 杉本典夫
// Time-stamp: <2024-05-08 13:54:37 tac>
//
// danse.1を表示するためのコマンド。
//
// 使用ライブラリ:libdanse.so, libfune.so
// コンパイル法 :g++ -O -s -W danse danse.C
//              -I/usr/local/include -L/usr/local/lib -ldanse -lfune

#include <danse.H>              // dans用ヘッダファイル(mate.H含む)

using namespace dans;           // dans名前空間使用(名前空間matvec含む)

const vecstr USAGE =            // プログラム使用法
{
  "danse  Version 7.40e        Copyleft (Vo\\oV) 2024 Sugimoto Norio",
  "USAGE:dans",
  "  Show the dans.1 file.",
  "OPTION:non"
};

int main(int argc, char* argv[]) // メインルーチン
{
  string pname = getname(argv[0]); // パス名なしのプログラム名取得
  try                           // 例外監視
  {
    help(pname, USAGE);
  }
  catch (help_except& helpex)   // ヘルプファイル表示
  { return 0; }
  catch (option_error& opterr)  // オプション指定エラー
  { return 1; }
  catch (runtime_error& rterr)  // 実行時エラー
  {
    disperr(pname, rterr.what());
    return 2;
  }
  catch (...)                   // 予期せぬ例外
  {
    disperr(pname, "Unknown error occurred !");
    return 255;
  }
  return 0;
}
